org.apache.tinkerpop.gremlin.structure

## Enum T

- java.lang.Object
- - java.lang.Enum<T>
  - - org.apache.tinkerpop.gremlin.structure.T

- All Implemented Interfaces:
    Serializable, Comparable<T>, Function<Element,Object>

      public enum T
      extends Enum<T>
      implements Function<Element,Object>

  A collection of (T)okens which allows for more concise Traversal definitions. T implements `Function` can be used to map an element to its token value. For example, `T.id.apply(element)`.
  Author:
    Marko A. Rodriguez (http://markorodriguez.com)

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `id` Id (representing Element.id())
    `key` Key (representing Property.key())
    `label` Label (representing Element.label())
    `value` Value (representing Property.value())

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract Object` | `apply(Element element)`
    `static T` | `fromString(String accessor)`
    `abstract String` | `getAccessor()`
    `static T` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static T[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.function.Function

      `andThen, compose, identity`

- - ### Enum Constant Detail

    - #### label

          public static final T label

      Label (representing Element.label())
      Since:
        3.0.0-incubating

    - #### id

          public static final T id

      Id (representing Element.id())
      Since:
        3.0.0-incubating

    - #### key

          public static final T key

      Key (representing Property.key())
      Since:
        3.0.0-incubating

    - #### value

          public static final T value

      Value (representing Property.value())
      Since:
        3.0.0-incubating

  - ### Method Detail

    - #### values

          public static T[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (T c : T.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static T valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### getAccessor

          public abstract String getAccessor()

    - #### apply

          public abstract Object apply(Element element)

      Specified by:
        `apply` in interface `Function<Element,Object>`

    - #### fromString

          public static T fromString(String accessor)

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.